unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, StdCtrls, FileCtrl, MSkinData, MMouseSkin,
  MPlayer, MScrollBar, MButton, MLedgeSkin, MLabel, MFormSkin, MBackSkin, Registry;

const crMyCursor = 1;

type
  TForm1 = class(TForm)
    MBackSkin1: TMBackSkin;
    MLabel1: TMLabel;
    MScrollBar1: TMScrollBar;
    Timer1: TTimer;
    Timer2: TTimer;
    MediaPlayer1: TMediaPlayer;
    MLedgeSkin1: TMLedgeSkin;
    MButton1: TMButton;
    MButton2: TMButton;
    MButton3: TMButton;
    MButton4: TMButton;
    MButton5: TMButton;
    MButton6: TMButton;
    OpenDialog1: TOpenDialog;
    MButton7: TMButton;
    MButton8: TMButton;
    MMouseSkin1: TMMouseSkin;
    MSkinData1: TMSkinData;
    PopupMenu1: TPopupMenu;
    Skinladen1: TMenuItem;
    OpenDialog2: TOpenDialog;
    RefreshSkin: TTimer;
    N1: TMenuItem;
    Magnetformonoff1: TMenuItem;
    MFormSkin1: TMFormSkin;
    Rememberpositiononoff1: TMenuItem;
    N2: TMenuItem;
    Centerform1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure MButton1Click(Sender: TObject);
    procedure MButton2Click(Sender: TObject);
    procedure MButton3Click(Sender: TObject);
    procedure MButton6Click(Sender: TObject);
    procedure MButton7Click(Sender: TObject);
    procedure MButton8Click(Sender: TObject);
    procedure Skinladen1Click(Sender: TObject);
    procedure RefreshSkinTimer(Sender: TObject);
    procedure Magnetformonoff1Click(Sender: TObject);
    procedure Rememberpositiononoff1Click(Sender: TObject);
    procedure Centerform1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
  DateiName, DateiName2 : string;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

ResourceString
   Settings = 'Software\MSkin\Settings\';

implementation

{$R *.DFM}

function MilliSecondsToString(MilliSeconds: integer): string;
var i1, i2: integer;
begin
i1:=(MilliSeconds div 1000) div 60;
i2:=(MilliSeconds div 1000)-(i1*60);
Result:=FormatFloat('00',i1)+':'+FormatFloat('00',i2);
end;

procedure TForm1.FormCreate(Sender: TObject);
var Eintrag : String;
    MagnetSetting, PositionSetting : Integer;
begin
with TRegistry.Create do
  begin
  OpenKey(Settings,True);
  Eintrag := Application.Title + '_' + Form1.Name;

  if ValueExists(Eintrag + '_Magnet') then
  MagnetSetting := ReadInteger(Eintrag + '_Magnet');
  if ValueExists(Eintrag + '_Position') then
  PositionSetting := ReadInteger(Eintrag + '_Position');

  if MagnetSetting = 1 then
  begin
  MagnetFormOnOff1.Checked := True;
  MLedgeSkin1.MagnetFormActive := True;
  end
  else
  begin
  MagnetFormOnOff1.Checked := False;
  MLedgeSkin1.MagnetFormActive := False;
  end;

  if PositionSetting = 1 then
  begin
  Rememberpositiononoff1.Checked := True;
  MLedgeSkin1.RememberPosition := True;
  end
  else
  begin
  Rememberpositiononoff1.Checked := False;
  MLedgeSkin1.RememberPosition := False;
  end;

  Free;
  end;


MFormSkin1.Init;
MMouseSkin1.FileName := ExtractFilePath(Application.EXEName) + 'Skins\Blue.bmp.ani';
MMouseSkin1.Init;
MBackSkin1.Init;
MScrollBar1.Init;
MLedgeSkin1.Init;
MButton1.Init;
MButton2.Init;
MButton3.Init;
MButton4.Init;
MButton5.Init;
MButton6.Init;
MButton7.Init;
MButton8.Init;
MSkinData1.AssignSkin;

end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
MBackSkin1.Draw;
MScrollBar1.Draw;
MLedgeSkin1.Draw;
MButton1.Draw;
MButton2.Draw;
MButton3.Draw;
MButton4.Draw;
MButton5.Draw;
MButton6.Draw;
MButton7.Draw;
MButton8.Draw;
MFormSkin1.Draw;

end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
MScrollBar1.Max := MediaPlayer1.Length;
MScrollBar1.Position := MediaPlayer1.Position;

end;

procedure TForm1.MButton1Click(Sender: TObject);
begin
if MediaPlayer1.Filename <> '' then
   begin
   Mediaplayer1.play;
   Timer2.enabled := true;
   end;

end;

procedure TForm1.MButton2Click(Sender: TObject);
begin
if MediaPlayer1.Filename <> '' then
   begin
   MediaPlayer1.Stop;
   MediaPlayer1.Rewind;
   end;

end;

procedure TForm1.MButton3Click(Sender: TObject);
begin
if Mediaplayer1.Filename <> '' then
MediaPlayer1.Pause;

end;

procedure TForm1.MButton6Click(Sender: TObject);
begin
if opendialog1.execute then
   begin
   if opendialog1.filename <> '' then
      begin
      MediaPlayer1.FileName := OpenDialog1.Filename;
      MediaPlayer1.Open;
      MediaPlayer1.Play;
      Dateiname := Copy(OpenDialog1.FileName,1,LastDelimiter('.',opendialog1.filename)-1);
      Dateiname2 := MinimizeName(Dateiname, Form1.Canvas, 0);
      MLabel1.Caption := '*** ' + DateiName2 + ' ' + '[' +  MillisecondsToString(MediaPlayer1.Length) + ']' + ' ***';
      Timer2.Enabled := True;
      end;
   end;

end;

procedure TForm1.MButton7Click(Sender: TObject);
begin
Application.Minimize;

end;

procedure TForm1.MButton8Click(Sender: TObject);
begin
Application.Terminate;

end;

procedure TForm1.Skinladen1Click(Sender: TObject);
begin
if (OpenDialog2.Execute) and (OpenDialog2.FileName <> '') then
begin
MSkinData1.Skin.LoadFromFile(OpenDialog2.Filename);
if FileExists(OpenDialog2.FileName + '.dat') then
begin
MSkinData1.SkinData.LoadFromFile(OpenDialog2.FileName + '.dat');
MSkinData1.AssignList(OpenDialog2.FileName + '.dat');
end;
MSkinData1.AssignSkin;
RefreshSkin.Enabled := True;
end;

end;

procedure TForm1.RefreshSkinTimer(Sender: TObject);
var i : Integer;
begin
for I := 0 to 10 do
begin
MLedgeSkin1.Repaint;
MFormSkin1.Repaint;
MBackSkin1.Repaint;
end;

RefreshSkin.Enabled := False;

end;

procedure TForm1.Magnetformonoff1Click(Sender: TObject);
begin
if MagnetFormOnOff1.Checked = True then
MagnetFormOnOff1.Checked := False
else
MagnetFormOnOff1.Checked := True;

if MagnetFormOnOff1.Checked = True then
MLedgeSkin1.MagnetFormActive := True
else
MLedgeSkin1.MagnetFormActive := False;

end;

procedure TForm1.Rememberpositiononoff1Click(Sender: TObject);
begin
if Rememberpositiononoff1.Checked = True then
Rememberpositiononoff1.Checked := False
else
Rememberpositiononoff1.Checked := True;

if Rememberpositiononoff1.Checked = True then
MLedgeSkin1.RememberPosition := True
else
MLedgeSkin1.RememberPosition := False;

end;

procedure TForm1.Centerform1Click(Sender: TObject);
begin
Form1.Position := poScreenCenter;

end;

procedure TForm1.FormDestroy(Sender: TObject);
var Eintrag : String;
    MagnetSetting, PositionSetting : Integer;
begin
if MagnetFormOnOff1.Checked = True then
MagnetSetting := 1
else
MagnetSetting := 0;

if Rememberpositiononoff1.Checked = True then
PositionSetting := 1
else
PositionSetting := 0;

with TRegistry.Create do
  begin
  OpenKey(Settings,True);
  Eintrag := Application.Title + '_' + Form1.Name;
  WriteInteger(Eintrag + '_Magnet', MagnetSetting);
  WriteInteger(Eintrag + '_Position', PositionSetting);
  Free;
  end;

end;

end.
